#!/usr/bin/perl

BEGIN { use File::Basename; unshift( @INC, ( File::Basename::dirname($0))) }

#
# --- set up required modules
#
use English;
use strict;
use Mozaix;
use Wx;
use vars qw(@ISA);
use Wx qw(:everything);
use Wx::Event qw(EVT_BUTTON EVT_RADIOBOX EVT_CHECKBOX EVT_LIST_ITEM_SELECTED EVT_CHECKLISTBOX);
my $INTERCEPT							= 	$ENV{"INTERCEPT"};
##
### NOTE:
## The ShowModal() method needs to addressed, it does not appear to work as expected. It always returns the value of 'Wx::wxID_CANCEL'.
##
if (1) {
	hello_world_example();
	string_example();
	radio_button_example();
	check_box_example();
	list_control_example();
	button_select_example();
	notebook_example();
	panel_example();
	checkbox_lister();
	get_color_dialog();
	wxwidget_tester();
	bitmap_button_tester();
	wxlister_tester_dialog();
	display_end_message();
}
################################################################################
sub hello_world_example
################################################################################ 
{
   my $dialog = Wx::MessageDialog->new(undef,'Welcome To The ITI WX Wdiget Demo........','ITI Message',wxICON_INFORMATION|wxCANCEL ,wxDefaultPosition);
   $dialog->ShowModal;
   $dialog->Destroy;
}

################################################################################
sub string_example
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Print Text Example");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item2 ) = Wx::StaticText->new( $dialog_ptr, -1, "Print Text:", wxDefaultPosition, wxDefaultSize, 0 );
    $item1->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::TextCtrl->new( $dialog_ptr, 10004, "", wxDefaultPosition, [120,-1], 0 );
    $item1->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item5 ) = Wx::Button->new( $dialog_ptr, 10001, "QUIT", wxDefaultPosition, wxDefaultSize, 0 );
    $item4->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item6 ) = Wx::Button->new( $dialog_ptr, 10002, "PRINT", wxDefaultPosition, wxDefaultSize, 0 );
    $item4->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	##
	## Always place events and update functions before the ShowModal command
	##
	EVT_BUTTON($dialog_ptr, 10001, \&PrintText_QUIT );
    EVT_BUTTON($dialog_ptr, 10002, \&PrintText_PRINT );
	#
	my $return_value = $dialog_ptr->ShowModal();
    ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Print Text Example dialog ....");
    }
}


################################################################################
sub PrintText_QUIT
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	$dialog_ptr->Close( 1 );
}

################################################################################
sub PrintText_PRINT
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	my $printTextPtr					=	getDialogWidgetPointer( $dialog_ptr, 10004 );
   	my $printTextStr					=	$printTextPtr->GetValue();
	Mozaix::output__note("	#----------------------------------------------------------#");
	Mozaix::output__note("	Input Text:[$printTextStr]");
	Mozaix::output__note("	#----------------------------------------------------------#");
	return;
}

################################################################################
sub radio_button_example
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Radio Button Example");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::RadioBox->new( $dialog_ptr, 10000, "Select A Button", wxDefaultPosition, wxDefaultSize, 
        ["Choice #1","Choice #2","Choice #3"] , 1, wxRA_SPECIFY_COLS );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item3 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Your Selection: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::StaticText->new( $dialog_ptr, 10001, "", wxDefaultPosition, [100,-1], 0 );
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::Button->new( $dialog_ptr, 10002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_RADIOBOX($dialog_ptr, 10000, \&Update_textCtrl);
	EVT_BUTTON($dialog_ptr, 10002, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
    ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Radio Buton Example dialog ....");
    }
}

################################################################################
sub Exit_Dialog
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	$dialog_ptr->Close( 1 );
}

################################################################################
sub Update_textCtrl
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	my $radiobutPtr					=	getDialogWidgetPointer( $dialog_ptr, 10000 );
   	my $radiobutTextStr				=	$radiobutPtr->GetStringSelection();
	#
	my $TextPtr					=	getDialogWidgetPointer( $dialog_ptr, 10001 );
   	$TextPtr->SetLabel($radiobutTextStr);

}

################################################################################
sub check_box_example
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Check Box Example");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::CheckBox->new( $dialog_ptr, 10000, "Test Status", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item3 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Check Box Status: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::StaticText->new( $dialog_ptr, 10001, "", wxDefaultPosition, [100,-1], 0 );
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::Button->new( $dialog_ptr, 10002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, 10002, \&Exit_Dialog );
	EVT_CHECKBOX($dialog_ptr, 10000, \&Update_ChkBox_Status );
	my $return_value = $dialog_ptr->ShowModal();
    ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Check Box Example dialog ....");
    }
}

################################################################################
sub Exit_Dialog
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	$dialog_ptr->Close( 1 );
}

################################################################################
sub Update_ChkBox_Status
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	my $chkBoxPtr					=	getDialogWidgetPointer( $dialog_ptr, 10000 );
   	my $chkBoxState					=	$chkBoxPtr->GetValue();
	#
	my $TextPtr					=	getDialogWidgetPointer( $dialog_ptr, 10001 );
	if ($chkBoxState)
	{
   		$TextPtr->SetLabel('Checked');
	} else {
		$TextPtr->SetLabel('NOT Checked');
	}
}

################################################################################
sub list_control_example
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "List Control Example");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::ListCtrl->new( $dialog_ptr, 10000, wxDefaultPosition, [160,120], wxLC_REPORT|wxLC_SINGLE_SEL|wxSUNKEN_BORDER );
	$item1->InsertColumn(   0, "Selections");
	$item1->SetColumnWidth( 0, 200 );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item3 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Selection: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::StaticText->new( $dialog_ptr, 10001, "", wxDefaultPosition, [100,-1], 0 );
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::Button->new( $dialog_ptr, 10002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	#
	EVT_BUTTON($dialog_ptr, 10002, \&Exit_Dialog );
	EVT_LIST_ITEM_SELECTED($dialog_ptr, 10000 , \&ON_Listbox_Select );
	update_lister_example($dialog_ptr);
    my $return_value = $dialog_ptr->ShowModal();

   ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled List Control Example dialog ....");
   }
}

################################################################################
sub Exit_Dialog
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	$dialog_ptr->Close( 1 );
}

################################################################################
sub ON_Listbox_Select
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	my $listPtr			=	getDialogWidgetPointer( $dialog_ptr, 10000 );
	my $TextPtr			=	getDialogWidgetPointer( $dialog_ptr, 10001 );
	#
   my $itemIndex = -1;
   my $selListItem	=	'';
   for ( ; ; )
   {
      $itemIndex = $listPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
      last if ( $itemIndex == -1 );
      $selListItem = $listPtr->GetItemText( $itemIndex ) ;
   }
   #
   $TextPtr->SetLabel($selListItem);
}

################################################################################
sub update_lister_example
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	my @listItems = ('Item #1','Item #2','Item #3','Item #4');
	my $listPtr			=	getDialogWidgetPointer( $dialog_ptr, 10000 );
	$listPtr->DeleteAllItems();
	my $I = 0;
   foreach my $name (@listItems)
   {
 	$listPtr->InsertStringItem( $I, $name);
  	$I++;
   }
}

################################################################################
sub button_select_example
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Button Select Example");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item2 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item3 ) = Wx::Button->new( $dialog_ptr, 10000, "Start", wxDefaultPosition, wxDefaultSize, 0 );
    $item3->SetForegroundColour( Wx::wxBLUE );
    $item2->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::Button->new( $dialog_ptr, 10001, "Stop", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::Button->new( $dialog_ptr, 10002, "Calculate", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item6 ) = Wx::Button->new( $dialog_ptr, 10003, "Ratio", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    $item1->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item7 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item8 ) = Wx::Button->new( $dialog_ptr, 10004, "Add", wxDefaultPosition, wxDefaultSize, 0 );
    $item7->AddWindow( $item8, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item9 ) = Wx::Button->new( $dialog_ptr, 10005, "Select", wxDefaultPosition, wxDefaultSize, 0 );
    $item9->SetBackgroundColour( Wx::wxRED );
    $item7->AddWindow( $item9, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item10 ) = Wx::Button->new( $dialog_ptr, 10006, "Drop", wxDefaultPosition, wxDefaultSize, 0 );
    $item7->AddWindow( $item10, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item11 ) = Wx::Button->new( $dialog_ptr, 10007, "Label#1", wxDefaultPosition, wxDefaultSize, 0 );
    $item7->AddWindow( $item11, 0, wxALIGN_CENTER|wxALL, 5 );

    $item1->Add( $item7, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item12 ) = Wx::Button->new( $dialog_ptr, 10008, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item12, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, 10000, \&Process_button_0 );
	EVT_BUTTON($dialog_ptr, 10001, \&Process_button_1 );
	EVT_BUTTON($dialog_ptr, 10002, \&Process_button_2 );
	EVT_BUTTON($dialog_ptr, 10003, \&Process_button_3 );
	EVT_BUTTON($dialog_ptr, 10004, \&Process_button_4 );
	EVT_BUTTON($dialog_ptr, 10005, \&Process_button_5 );
	EVT_BUTTON($dialog_ptr, 10006, \&Process_button_6 );
	EVT_BUTTON($dialog_ptr, 10007, \&Process_button_7 );
	EVT_BUTTON($dialog_ptr, 10008, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();

   ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Button Example dialog ....");
   }

}

################################################################################
sub Exit_Dialog
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	$dialog_ptr->Close( 1 );
}

################################################################################
sub Process_button_0
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'START' button......" );
}
################################################################################
sub Process_button_1
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'STOP' button......" );
}
################################################################################
sub Process_button_2
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'CALCULATE' button......" );
}
################################################################################
sub Process_button_3
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'RATIO' button......" );
}
################################################################################
sub Process_button_4
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'ADD' button......" );
}
################################################################################
sub Process_button_5
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'SELECT' button......" );
}
################################################################################
sub Process_button_6
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	display_button_message($dialog_ptr,"You have pushed the 'DROP' button......" );
}
################################################################################
sub Process_button_7
################################################################################
{
	my ($dialog_ptr)   = @_;
	#
	my $butPtr	=	getDialogWidgetPointer( $dialog_ptr, 10007 );
	my $label = $butPtr->GetLabel();
	if ($label eq 'Label#1')
	{ 
		$butPtr->SetLabel('Label#2');
	} else {
		$butPtr->SetLabel('Label#1');
	}
}

################################################################################
sub display_button_message
################################################################################ 
{
	my ($dialog_ptr,$message)	=	@_;
   #
   my $dialog = Wx::MessageDialog->new($dialog_ptr,$message,'Simulation Setup',wxICON_INFORMATION|wxOK,wxDefaultPosition);
   $dialog->ShowModal;
   $dialog->Destroy;
}

################################################################################
sub notebook_example
################################################################################
{
	##
	$main::ID_SLTX_10000	=	10001;
	$main::ID_SNBT_10001	=	10001;
	$main::ID_CKBX_20000	=	20000;
	$main::ID_STTX_20001	=	20001;
	##
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Notebook Example");
    my( $vertSizerPtr ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $notebookPtr ) = Wx::Notebook->new( $dialog_ptr, -1, wxDefaultPosition, [200,160], 0 );
    my( $item1 ) = $notebookPtr;
    if( Wx->VERSION < 0.21 ) {
        $item1 = Wx::NotebookSizer->new( $notebookPtr );
    }
    
    my( $print_string_Panel_Ptr ) = Wx::Panel->new( $notebookPtr, -1 );
    print_string_panel_gadget( $print_string_Panel_Ptr);
    $notebookPtr->AddPage( $print_string_Panel_Ptr, "Print String" );

    my( $check_box_Panel_Ptr ) = Wx::Panel->new( $notebookPtr, -1 );
    checkbox_status_panel_gadget( $check_box_Panel_Ptr);
    $notebookPtr->AddPage( $check_box_Panel_Ptr, "Check Box Status" );

    $vertSizerPtr->Add( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $vertSizerPtr );
         
         if( $call_fit == 1 ) {
             $vertSizerPtr->SetSizeHints( $dialog_ptr );
         }
    }
    
    $vertSizerPtr;
	EVT_BUTTON($notebookPtr, $main::ID_SNBT_10001, \&Process_Notebook_TAB_Print_Command );
	EVT_CHECKBOX($notebookPtr, $main::ID_CKBX_20000, \&Process_Notebook_TAB_CheckBox_Status );
	my $return_value = $dialog_ptr->ShowModal();
   ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Notebook Example dialog ....");
   }
}

################################################################################
sub Process_Notebook_TAB_Print_Command
################################################################################
{
	my ($dialog_ptr) = @_;
	#
	my $printTextPtr					=	getDialogWidgetPointer( $dialog_ptr, $main::ID_SLTX_10000 );
   	my $printTextStr					=	$printTextPtr->GetValue();
	Mozaix::output__note("	#----------------------------------------------------------#");
	Mozaix::output__note("	Input Text:[$printTextStr]");
	Mozaix::output__note("	#----------------------------------------------------------#");
	return;
}

################################################################################
sub Process_Notebook_TAB_CheckBox_Status
################################################################################
{
	my ($dialog_ptr) = @_;
	#
	my $chkBoxPtr					=	getDialogWidgetPointer( $dialog_ptr, $main::ID_CKBX_20000 );
   	my $chkBoxState					=	$chkBoxPtr->GetValue();
	#
	my $TextPtr					=	getDialogWidgetPointer( $dialog_ptr, $main::ID_STTX_20001 );
	if ($chkBoxState)
	{
   		$TextPtr->SetLabel('Checked');
	} else {
		$TextPtr->SetLabel('NOT Checked');
	}
}

################################################################################
sub print_string_panel_gadget
################################################################################
{
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item2 ) = Wx::StaticText->new( $_[0], -1, "Print Text:", wxDefaultPosition, wxDefaultSize, 0 );
    $item1->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::TextCtrl->new( $_[0], $main::ID_SLTX_10000, "", wxDefaultPosition, [120,-1], 0 );
    $item1->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item6 ) = Wx::Button->new( $_[0], $main::ID_SNBT_10001, "PRINT", wxDefaultPosition, wxDefaultSize, 0 );
    $item4->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $_[0]->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $_[0] );
         }
    }
    
    $item0;
}

################################################################################
sub checkbox_status_panel_gadget
################################################################################
{
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::CheckBox->new( $_[0], $main::ID_CKBX_20000, "Test Status", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item3 ) = Wx::StaticText->new( $_[0], -1, "Check Box Status: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::StaticText->new( $_[0], $main::ID_STTX_20001, "", wxDefaultPosition, [100,-1], 0 );
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $_[0]->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $_[0] );
         }
    }
    
    $item0;
}


################################################################################
sub panel_example
################################################################################
{
	$main::ID_SNBT_30000	=	30000;
	$main::ID_PANEL_30001	=	30001;
	$main::ID_PANEL_30002	=	30002;
	#
	$main::ID_SNBT_40000	=	40000;
	$main::ID_RDBX_40001	=	40001;
	$main::ID_TXCT_40002	=	40002;
	#
	$main::ID_SNBT_50000	=	50000;
	$main::ID_CKBX_50001	=	50001;
	$main::ID_CKBX_50002	=	50002;
	$main::ID_CKBX_50003	=	50003;
	$main::ID_TXCT_50004	=	50004;
	$main::TOGGLE_STATE		=	1;
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Panel Example");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    $main::Panel_A_Sizer = Wx::BoxSizer->new( wxVERTICAL );
    
    $main::Panel_A_Ptr = Wx::Panel->new( $dialog_ptr, $main::ID_PANEL_30001, wxDefaultPosition, [200,160], 0);
	CREATE__panel_A_widget($main::Panel_A_Ptr);
    $main::Panel_A_Sizer->AddWindow( $main::Panel_A_Ptr, 0, wxALIGN_CENTER|wxALL, 5 );
	$main::Panel_A_Sizer->Show($main::Panel_A_Ptr,1);

    $item0->Add( $main::Panel_A_Sizer, 0, wxALIGN_CENTER|wxALL, 5 );

    $main::Panel_B_Sizer = Wx::BoxSizer->new( wxVERTICAL );
    
    $main::Panel_B_Ptr = Wx::Panel->new( $dialog_ptr, $main::ID_PANEL_30002, wxDefaultPosition, [200,160], 0);
	CREATE__panel_B_widget($main::Panel_B_Ptr);
    $main::Panel_B_Sizer->AddWindow( $main::Panel_B_Ptr, 0, wxALIGN_CENTER|wxALL, 5 );
	$main::Panel_B_Sizer->Show($main::Panel_B_Ptr,0);

    $item0->Add( $main::Panel_B_Sizer, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::Button->new( $dialog_ptr, $main::ID_SNBT_30000, "Toggle Panels", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_30000, \&Process_Panel_Button );
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_40000, \&Process_Panel_A_Button );
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_50000, \&Process_Panel_B_Button );
	my $return_value = $dialog_ptr->ShowModal();
   ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Panel Example dialog ....");
   }
}


################################################################################
sub Process_Panel_Button
################################################################################
{
	my ($dialog_ptr) = @_;
	#
	if ($main::TOGGLE_STATE)
	{
		$main::Panel_A_Sizer->Show($main::Panel_A_Ptr,0);
		$main::Panel_B_Sizer->Show($main::Panel_B_Ptr,1);
		$main::TOGGLE_STATE	=	0;	
	} else {
		$main::Panel_A_Sizer->Show($main::Panel_A_Ptr,1);
		$main::Panel_B_Sizer->Show($main::Panel_B_Ptr,0);
		$main::TOGGLE_STATE	=	1;
	}

}

################################################################################
sub Process_Panel_A_Button
################################################################################
{
	my ($dialog_ptr) = @_;
	#
	my $radiobutPtr					=	getDialogWidgetPointer( $dialog_ptr, $main::ID_RDBX_40001 );
   	my $radiobutTextStr				=	$radiobutPtr->GetStringSelection();
	#
	my $TextCtrlPtr					=	getDialogWidgetPointer( $dialog_ptr, $main::ID_TXCT_40002 );
   	$TextCtrlPtr->SetValue($radiobutTextStr);
}

################################################################################
sub Process_Panel_B_Button
################################################################################
{
	my ($dialog_ptr) = @_;
	#
	my $setStr	=	'';
	my $chkbox_A_Ptr				=	getDialogWidgetPointer( $dialog_ptr, $main::ID_CKBX_50001 );
   	my $chkbox_A_State				=	$chkbox_A_Ptr->GetValue();
	if ($chkbox_A_State)
	{
		$setStr .= ' A ';	
	}
	#
	my $chkbox_B_Ptr				=	getDialogWidgetPointer( $dialog_ptr, $main::ID_CKBX_50002 );
   	my $chkbox_B_State				=	$chkbox_B_Ptr->GetValue();
	if ($chkbox_B_State)
	{
		$setStr .= ' B ';	
	}
	#
	my $chkbox_C_Ptr				=	getDialogWidgetPointer( $dialog_ptr, $main::ID_CKBX_50003 );
   	my $chkbox_C_State				=	$chkbox_C_Ptr->GetValue();
	if ($chkbox_C_State)
	{
		$setStr .= ' C ';	
	}
	#
	my $TextCtrlPtr					=	getDialogWidgetPointer( $dialog_ptr, $main::ID_TXCT_50004 );
	#
	 
   	$TextCtrlPtr->SetValue($setStr);
}

################################################################################
sub CREATE__panel_A_widget
################################################################################
{
    my( $item1 ) = Wx::StaticBox->new( $_[0], -1, "Panel A" );
    my( $item0 ) = Wx::StaticBoxSizer->new( $item1, wxVERTICAL );
    
    my( $item2 ) = Wx::RadioBox->new( $_[0], $main::ID_RDBX_40001, "Panel A Functions", wxDefaultPosition, wxDefaultSize, 
        ["Stop","Start","Reset"] , 1, wxRA_SPECIFY_COLS );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item4 ) = Wx::StaticText->new( $_[0], $main::ID_TEXT, "Selected Function: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item3->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::TextCtrl->new( $_[0], $main::ID_TXCT_40002, "", wxDefaultPosition, [80,-1], 0 );
    $item3->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item6 ) = Wx::Button->new( $_[0], $main::ID_SNBT_40000, "Print Selection", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $_[0]->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $_[0] );
         }
    }
    
    $item0;
}

################################################################################
sub CREATE__panel_B_widget
################################################################################
{
    my( $item1 ) = Wx::StaticBox->new( $_[0], -1, "Panel B" );
    my( $item0 ) = Wx::StaticBoxSizer->new( $item1, wxVERTICAL );
    
    my( $item3 ) = Wx::StaticBox->new( $_[0], -1, "Panel B Functions" );
    my( $item2 ) = Wx::StaticBoxSizer->new( $item3, wxVERTICAL );
    
    my( $item4 ) = Wx::CheckBox->new( $_[0], $main::ID_CKBX_50001, "Save A", wxDefaultPosition, [80,-1], 0 );
    $item4->SetValue(1);
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::CheckBox->new( $_[0], $main::ID_CKBX_50002, "Save B", wxDefaultPosition, [80,-1], 0 );
    $item2->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item6 ) = Wx::CheckBox->new( $_[0], $main::ID_CKBX_50003, "Save C", wxDefaultPosition, [80,-1], 0 );
    $item2->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item7 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item8 ) = Wx::StaticText->new( $_[0], $main::ID_TEXT, "Save: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item7->AddWindow( $item8, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item9 ) = Wx::TextCtrl->new( $_[0], $main::ID_TXCT_50004, "", wxDefaultPosition, [150,-1], 0 );
    $item7->AddWindow( $item9, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item7, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item10 ) = Wx::Button->new( $_[0], $main::ID_SNBT_50000, "Process Saves", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item10, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $_[0]->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $_[0] );
         }
    }
    
    $item0;
}

################################################################################
sub display_end_message
################################################################################ 
{
   my ($dialog_ptr)	=	@_;
   #
   my $dialog = Wx::MessageDialog->new($dialog_ptr,'    This Concludes The ITI WxWidgets Demo    ','ITI Message',wxICON_INFORMATION|wxOK ,wxDefaultPosition);
   $dialog->ShowModal;
   $dialog->Destroy;
}

################################################################################
sub checkbox_lister
################################################################################
{
	$main::ID_CKBX_60000	=	60000;
	$main::ID_TXCT_60001	=	60001;
	##
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Checkbox Lister Example");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::CheckListBox->new( $dialog_ptr, $main::ID_CKBX_60000, wxDefaultPosition, [80,100], 
        ["Red","White","Blue","Green"] , wxLB_SINGLE );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item3 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Selection: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item2->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::TextCtrl->new( $dialog_ptr, $main::ID_TXCT_60001, "", wxDefaultPosition, [200,-1], 0 );
    $item2->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

	my( $item5 ) = Wx::Button->new( $dialog_ptr, $main::ID_BUTTON, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_CHECKLISTBOX($dialog_ptr, $main::ID_CKBX_60000, \&process_chkbox_lister);
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_60002, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub process_chkbox_lister
################################################################################
{
	my ($dialog_ptr)	=	@_;
   	#
	my $chkbox_Ptr		=	getDialogWidgetPointer( $dialog_ptr, $main::ID_CKBX_60000 );
	#
	my @selections =	('Red','White','Blue','Green');
	my $outStr	=	'';
	my $I=0;
	for ($I=0;$I<=3;$I++)
	{
		my $status = $chkbox_Ptr->IsChecked($I);
		next if ($status eq '');
		if ($status)
		{
			$outStr .= " $selections[$I] ";
		}
	}
	my $lstctrl_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_TXCT_60001 );
	$lstctrl_Ptr->SetValue($outStr);
}

################################################################################
sub get_color_dialog
################################################################################ 
{
	$main::ID_TXCT_80000	=	80000;
	$main::ID_GAUG_80001	=	80001;
	$main::ID_TXCT_80002	=	80002;
	$main::ID_GAUG_80003	=	80003;
	$main::ID_TXCT_80004	=	80004;
	$main::ID_GAUG_80005	=	80005;
	$main::ID_SNBT_80006	=	80006;
	$main::ID_SNBT_80007	=	80007;
	#
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Colour Control Example");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item2 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Red", wxDefaultPosition, [30,-1], 0 );
    $item1->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::TextCtrl->new( $dialog_ptr, $main::ID_TXCT_80000, "", wxDefaultPosition, [40,-1], 0 );
    $item1->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::Gauge->new( $dialog_ptr, $main::ID_GAUG_80001, 255, wxDefaultPosition, [100,-1], 0 );
    $item1->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item6 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Green", wxDefaultPosition, [30,-1], 0 );
    $item5->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item7 ) = Wx::TextCtrl->new( $dialog_ptr, $main::ID_TXCT_80002, "", wxDefaultPosition, [40,-1], 0 );
    $item5->AddWindow( $item7, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item8 ) = Wx::Gauge->new( $dialog_ptr, $main::ID_GAUG_80003, 255, wxDefaultPosition, [100,-1], 0 );
    $item5->AddWindow( $item8, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item9 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item10 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Blue", wxDefaultPosition, [30,-1], 0 );
    $item9->AddWindow( $item10, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item11 ) = Wx::TextCtrl->new( $dialog_ptr, $main::ID_TXCT_80004, "", wxDefaultPosition, [40,-1], 0 );
    $item9->AddWindow( $item11, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item12 ) = Wx::Gauge->new( $dialog_ptr, $main::ID_GAUG_80005, 255, wxDefaultPosition, [100,-1], 0 );
    $item9->AddWindow( $item12, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item9, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item13 ) = Wx::Button->new( $dialog_ptr, $main::ID_SNBT_80006, "Get Colour Data", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item13, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item14 ) = Wx::StaticLine->new( $dialog_ptr, $main::ID_LINE, wxDefaultPosition, [300,-1], wxLI_HORIZONTAL );
    $item0->AddWindow( $item14, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item15 ) = Wx::Button->new( $dialog_ptr, $main::ID_SNBT_80007, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item15, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_80006, \&process_colour_data);
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_80007, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub process_colour_data
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my ($red,$green,$blue) = color_dialog();
	#
	my $RED_lstctrl_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_TXCT_80000 );
	my $RED_gauge_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_GAUG_80001 );
	$RED_lstctrl_Ptr->SetValue($red);
	$RED_gauge_Ptr->SetValue($red);
	#
	my $GREEN_lstctrl_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_TXCT_80002 );
	my $GREEN_gauge_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_GAUG_80003 );
	$GREEN_lstctrl_Ptr->SetValue($green);
	$GREEN_gauge_Ptr->SetValue($green);
	#
	my $BLUE_lstctrl_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_TXCT_80004 );
	my $BLUE_gauge_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_GAUG_80005 );
	$BLUE_lstctrl_Ptr->SetValue($blue);
	$BLUE_gauge_Ptr->SetValue($blue);
}

################################################################################
sub color_dialog
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
    my $dialog  = Wx::ColourDialog->new( $dialog_ptr);
    $dialog->ShowModal;
	my $colors = $dialog->GetColourData();
	my $colors_ptr	= $colors->GetColour();
	my @returnData	=	();	
	my $red 	=  	$colors_ptr->Red();
	push(@returnData,$red);
	my $green	=	$colors_ptr->Green();
	push(@returnData,$green);
	my $blue 	= 	$colors_ptr->Blue();
	push(@returnData,$blue);
	#print "[$red][$green][$blue]\n";
    $dialog->Destroy;
	return @returnData; 
}

################################################################################
sub wxwidget_tester
################################################################################ 
{
	$main::ID_TXCT_90000	=	90000;
	$main::ID_RDBX_90001	=	90001;
	$main::ID_SNBT_90002	=	90002;
	$main::ID_SNBT_90003	=	90003;
	#
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "WX Dialog Tester");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "WX DIALOG WIDGET TESTER", wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::StaticLine->new( $dialog_ptr, $main::ID_LINE, wxDefaultPosition, [320,-1], wxLI_HORIZONTAL );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
    my( $item4 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "WX Command: ", wxDefaultPosition, wxDefaultSize, 0 );
    $item3->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::TextCtrl->new( $dialog_ptr, $main::ID_TXCT_90000, "", wxDefaultPosition, [200,-1], wxTE_READONLY );
    $item3->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item6 ) = Wx::RadioBox->new( $dialog_ptr, $main::ID_RDBX_90001, "WX Dialogs:", wxDefaultPosition, wxDefaultSize, 
        ["Directory Select","File Select","Find Replace","Font Select","Mutiple Choice","Numeric Input","Page Setup","Print","Progress","Single Choice","Text Entry"] , 1, wxRA_SPECIFY_COLS );
    $item0->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item7 ) = Wx::Button->new( $dialog_ptr, $main::ID_SNBT_90002, "TEST", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item7, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item8 ) = Wx::StaticLine->new( $dialog_ptr, $main::ID_LINE, wxDefaultPosition, [320,-1], wxLI_HORIZONTAL );
    $item0->AddWindow( $item8, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item9 ) = Wx::Button->new( $dialog_ptr, $main::ID_SNBT_90003, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item9, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_90002, \&process_dialog_test_choice);
	EVT_BUTTON($dialog_ptr, $main::ID_SNBT_90003, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub process_dialog_test_choice
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $txtctrl_Ptr		=	getDialogWidgetPointer( $dialog_ptr,$main::ID_TXCT_90000 );
	my $radioBox_Ptr	=	getDialogWidgetPointer( $dialog_ptr,$main::ID_RDBX_90001 );
	my $selection	=	$radioBox_Ptr->GetStringSelection();
	if ($selection eq 'Directory Select')
	{
		$txtctrl_Ptr->SetValue('Wx::DirDialog');
		select_directory_path($dialog_ptr);
	} elsif ($selection eq 'File Select') {
		$txtctrl_Ptr->SetValue('Wx::FileDialog');
		select_file_path($dialog_ptr);
	} elsif ($selection eq 'Find Replace') {
		$txtctrl_Ptr->SetValue('Wx::FindReplaceDialog');
		find_replace($dialog_ptr);
	} elsif ($selection eq 'Font Select') {
		$txtctrl_Ptr->SetValue('Wx::FontDialog');
		select_font($dialog_ptr);
	} elsif ($selection eq 'Mutiple Choice') {
		$txtctrl_Ptr->SetValue('Wx::MultiChoiceDialog');
		multi_choice_select($dialog_ptr);
	} elsif ($selection eq 'Numeric Input') {
		# Wx::NumberEntryDialog::new(CLASS, parent, message, prompt, caption, value, min, max, pos)
		$txtctrl_Ptr->SetValue('Wx::NumberEntryDialog');
		numeric_entery($dialog_ptr);
	} elsif ($selection eq 'Page Setup') {
		$txtctrl_Ptr->SetValue('Wx::PageSetupDialog');
		page_setup($dialog_ptr);
	} elsif ($selection eq 'Print') {
		$txtctrl_Ptr->SetValue('Wx::PrintDialog');
		print_setup($dialog_ptr);
	} elsif ($selection eq 'Progress') {
		$txtctrl_Ptr->SetValue('Wx::ProgressDialog');
		view_progress($dialog_ptr);
	} elsif ($selection eq 'Single Choice') {
		$txtctrl_Ptr->SetValue('Wx::SingleChoiceDialog');
		single_choice_select($dialog_ptr);
	} elsif ($selection eq 'Text Entry') {
		$txtctrl_Ptr->SetValue('Wx::TextEntryDialog');
		get_text_entry($dialog_ptr);
	} else { ; }
	#$txtctrl_Ptr->SetValue($red);
}

################################################################################
sub select_directory_path
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $INTERCEPT_DESIGN	=	$ENV{"INTERCEPT_DESIGN"};
	my $dialog  = Wx::DirDialog->new( $dialog_ptr,"Choose a directory",$INTERCEPT_DESIGN,wxDD_NEW_DIR_BUTTON);
    $dialog->ShowModal;
	my $selectedPath = $dialog->GetPath();
	my $msgstr = 'Selected Directory SPath:[ ' . "$selectedPath" . ']';
	display_results($dialog_ptr,$msgstr);
	$dialog->Destroy;
}

################################################################################
sub select_file_path
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $INTERCEPT_DESIGN	=	$ENV{"INTERCEPT_DESIGN"};
	my $dialog  = Wx::FileDialog->new( $dialog_ptr,"Choose a file",$INTERCEPT_DESIGN,'',"*.*",wxOPEN |wxFILE_MUST_EXIST|wxCHANGE_DIR);
    $dialog->ShowModal;
	my $selectedPath = $dialog->GetPath();
	my $msgstr = 'Selected File Path:[ ' . "$selectedPath" . ']';
	display_results($dialog_ptr,$msgstr);
	$dialog->Destroy;
}

################################################################################
sub find_replace
################################################################################
{
	my ($dialog_ptr)	=	@_;
    # Wx::FindReplaceDialog::new(CLASS, parent, data, title, style = 0)
	#my $dialog  = Wx::FindReplaceDialog->new(undef, $dialog_ptr, '', 'Find And Replace Dialog',0);
    #$dialog->ShowModal;
	#$dialog->Destroy;
	display_results($dialog_ptr,'This Dialog NOT Operational At This Time.........');
}

################################################################################
sub select_font
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $dialog  = Wx::FontDialog->new( $dialog_ptr);
    $dialog->ShowModal;
	my $fonts_data_ptr = $dialog->GetFontData();
	my $fontsPtr	= $fonts_data_ptr->GetChosenFont();
	my $fontType = $fontsPtr->GetFaceName();
	my $Pointsize = $fontsPtr->GetPointSize();
	my $Style = $fontsPtr->GetStyle();
	my $weight = $fontsPtr->GetWeight();
	Mozaix::output__note("	#----------------------------------------------------------#");
	Mozaix::output__note("	FONT INFORMATION:");
	Mozaix::output__note("	      Font Type:[$fontType]");
	Mozaix::output__note("	     Point Size:[$Pointsize] points");
	Mozaix::output__note("	          Style:[$Style]");
	Mozaix::output__note("	         Weight:[$weight]");
	Mozaix::output__note("	#----------------------------------------------------------#");
	$dialog->Destroy;
}

################################################################################
sub multi_choice_select
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my @entries = ('Item-1','Item-2','Item-3','Item-4','Item-5');
	my $dialog = Wx::MultiChoiceDialog->new($dialog_ptr,'Make Your Selections','Muti-Choice Selection Dialog',["Item-1","Item-2","Item-3","Item-4","Item-5"] ,wxOK,wxDefaultPosition);
   	$dialog->ShowModal;
	my @selections = $dialog->GetSelections();
	my $msgStr	=	'';
	foreach my $selection (@selections)
	{
		$msgStr .= " $entries[$selection] ";
	}
	display_results($dialog_ptr,$msgStr);
   	$dialog->Destroy;
}

################################################################################
sub numeric_entery
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $dialog = Wx::NumberEntryDialog::new(undef, $dialog_ptr, 'Number must be between 0-100', 'Enter A Number', 'Numeric Entry Dialog', 0, 0, 100,wxDefaultPosition);
	$dialog->ShowModal;
	my $userValue	=	$dialog->GetValue();
	display_results($dialog_ptr,$userValue);
	$dialog->Destroy;
}

################################################################################
sub page_setup
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	#my $dataPtr	=	Wx::PageSetupDialogData->new(undef);
	#my $dialog  = Wx::PageSetupDialog->new(undef, $dialog_ptr, $dataPtr);
    #$dialog->ShowModal;
	#$dialog->Destroy;
	display_results($dialog_ptr,'This Dialog NOT Operational At This Time.........');
}

################################################################################
sub print_setup
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	#my $dialog  = Wx::PrintDialog->new(undef,$dialog_ptr,0);
    #$dialog->ShowModal;
	#$dialog->Destroy;
	display_results($dialog_ptr,'This Dialog NOT Operational At This Time.........');
}

################################################################################
sub view_progress
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $cont	=	1;
	my $dialog  = Wx::ProgressDialog->new('System Progress','Time Left',10,$dialog_ptr,wxPD_APP_MODAL|wxPD_CAN_ABORT|wxPD_ELAPSED_TIME|wxPD_ESTIMATED_TIME|wxPD_REMAINING_TIME);
	my $I=0;
	my $J=0;
	for ($I=0;$I<=1000;$I++)
	{
		for ($J=0;$J<=100000;$J++)
		{
			;
		}
		if ($I == 1000)
		{
			$cont	= $dialog->Update($I,'Thats All Folks!!');	
		} elsif ($I == 500) {
			$cont	= $dialog->Update($I,'Half Way To Home!!');
		} else {
			$cont	= $dialog->Update($I);
		}
		if (!$cont)
		{
			$dialog->Destroy;	
		}
	}
	#display_results($dialog_ptr,'This Dialog Needs More Work.........');
}

################################################################################
sub single_choice_select
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $dialog = Wx::SingleChoiceDialog->new($dialog_ptr,'Make Your Selection','Please enter text',["Item-1","Item-2","Item-3","Item-4","Item-5"] ,["Item-1","Item-2","Item-3","Item-4","Item-5"],wxOK,wxDefaultPosition);
   	$dialog->ShowModal;
	my $selection = $dialog->GetStringSelection();
	display_results($dialog_ptr,$selection);
   	$dialog->Destroy;

}

################################################################################
sub get_text_entry
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $dialog = Wx::TextEntryDialog->new($dialog_ptr,'Text Entry Dialog','Single Selection Dialog',"",wxOK|wxCANCEL,wxDefaultPosition);
   	$dialog->ShowModal;
	my $selection = $dialog->GetValue();
	display_results($dialog_ptr,$selection);
   	$dialog->Destroy;
}

################################################################################
sub display_results
################################################################################
{
	my ($dialog_ptr,$msgStr)	=	@_;
   	#
	my $dialog = Wx::MessageDialog->new($dialog_ptr,$msgStr,'Dialog Tester Results',wxICON_INFORMATION|wxOK ,wxDefaultPosition);
   	$dialog->ShowModal;
   	$dialog->Destroy;
}

################################################################################
sub wxlister_tester_dialog
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "WX Lister Dialog Tester");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::StaticText->new( $dialog_ptr, -1, "Wx Lister Widget Tester", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::StaticLine->new( $dialog_ptr, -1, wxDefaultPosition, [320,-1], wxLI_HORIZONTAL );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::RadioBox->new( $dialog_ptr, 100, "Wx Lister", wxDefaultPosition, wxDefaultSize, 
        ["Single Column Single Selection","Single Column Multi-Selection","Multi-Column Single Selection","Multi-Column Multi-Selection","Multi-Column"] , 1, wxRA_SPECIFY_COLS );
    $item0->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item4 ) = Wx::Button->new( $dialog_ptr, 101, "Test Lister Gadget", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::StaticLine->new( $dialog_ptr, -1, wxDefaultPosition, [320,-1], wxLI_HORIZONTAL );
    $item0->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item6 ) = Wx::Button->new( $dialog_ptr, 102, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item6, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, 101, \&process_lister_test_choice);
	EVT_BUTTON($dialog_ptr, 102, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub process_lister_test_choice
################################################################################
{
	my ($dialog_ptr)	=	@_;
    #
	my $radioBox_Ptr	=	getDialogWidgetPointer( $dialog_ptr,100 );
	my $selection	=	$radioBox_Ptr->GetStringSelection();
	if ($selection eq 'Single Column Single Selection')
	{
		scss_lister_dialog();
	} elsif ($selection eq 'Single Column Multi-Selection') {
		scms_lister_dialog();
	} elsif ($selection eq 'Multi-Column Single Selection') {
		mcss_lister_dialog();
	} elsif ($selection eq 'Multi-Column Multi-Selection') {
		mcms_lister_dialog();
	} elsif ($selection eq 'Multi-Column') {
		mc_lister_dialog();
	} else { ; }
}

################################################################################
sub scss_lister_dialog
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Single Column Single Selection WX Lister ");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::ListCtrl->new( $dialog_ptr, 1000, wxDefaultPosition, [160,120], wxLC_REPORT|wxLC_SINGLE_SEL|wxSUNKEN_BORDER );
	$item1->InsertColumn(   0, "Items");
	$item1->SetColumnWidth( 0, 200 );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::Button->new( $dialog_ptr, 1001, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	update_scss_lister($dialog_ptr);
	EVT_LIST_ITEM_SELECTED($dialog_ptr, 1000, \&process_scss_selection );
	EVT_BUTTON($dialog_ptr, 1001, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled SCSS Lister dialog ....");
   	}
}

################################################################################
sub update_scss_lister
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my @lister_items    = ('item-1','item-2','item-3','item-4','item-5','item-6');
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
   my $index;
   my $I = 0;
   if (scalar(@lister_items > 0))
   { 
      foreach my $entry ( @lister_items ) 
      {
         $index = $listBoxPtr->InsertStringItem( $I, $entry);
         $I++;
      }
   } else {
   	$index = $listBoxPtr->InsertStringItem( $I, 'No lister items found .......');
   }
}

################################################################################
sub process_scss_selection
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	my $selectCount = $listBoxPtr->GetSelectedItemCount;
  	if ( $selectCount == 0 )
  	{
     	Mozaix::output__warning("Please Note: A list box entry must be selected ... returning!");
     	return 0;
  	}

  	## Obtain the text of the selected dialog entry; please note that this
  	## approach ONLY returns the field of information in COLUMN 1!
  	my $itemIndex = -1;
	my $selectedItem =	'';
  	for ( ; ; )
  	{
    	$itemIndex = $listBoxPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
     	last if ( $itemIndex == -1 );
     	$selectedItem = $listBoxPtr->GetItemText( $itemIndex ) ;
  	}
	my $msgstr = "Selected Entry ==> $selectedItem";
	display_results($dialog_ptr,$msgstr);

} 

################################################################################
sub scms_lister_dialog
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Single Column Multiple Selection WX Lister ");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::ListCtrl->new( $dialog_ptr, 1000, wxDefaultPosition, [160,120], wxLC_REPORT|wxSUNKEN_BORDER );
	$item1->InsertColumn(   0, "Items");
	$item1->SetColumnWidth( 0, 200 );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::Button->new( $dialog_ptr, 1001, "Print Selections", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

	my( $item3 ) = Wx::Button->new( $dialog_ptr, 1002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	update_scss_lister($dialog_ptr);
	EVT_BUTTON($dialog_ptr, 1001, \&process_scms_selection );
	EVT_BUTTON($dialog_ptr, 1002, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled SCMS Lister dialog ....");
   	}
}

################################################################################
sub process_scms_selection
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my @selectedItems	=	();
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	my $selectCount = $listBoxPtr->GetSelectedItemCount;
  	if ( $selectCount == 0 )
  	{
     	Mozaix::output__warning("Please Note: At least -1- list box entry must be selected ... returning!");
     	return 0;
  	}

  	## Obtain the text of the selected dialog entry; please note that this
  	## approach ONLY returns the field of information in COLUMN 1!
  	my $itemIndex = -1;
	my $selectedItem =	'';
  	for ( ; ; )
  	{
    	$itemIndex = $listBoxPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
     	last if ( $itemIndex == -1 );
     	$selectedItem = $listBoxPtr->GetItemText( $itemIndex ) ;
		push(@selectedItems,$selectedItem);
  	}
	##
	my $msgStr	=	'';
	foreach my $selection (@selectedItems)
	{
		$msgStr .= " $selection ";
	}
	display_results($dialog_ptr,$msgStr);
} 

################################################################################
sub mcss_lister_dialog
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Multiple Column Single Selection WX Lister ");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::ListCtrl->new( $dialog_ptr, 1000, wxDefaultPosition, [300,120], wxLC_REPORT|wxLC_SINGLE_SEL|wxSUNKEN_BORDER );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

	my( $item2 ) = Wx::Button->new( $dialog_ptr, 1001, "Print Selection", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::Button->new( $dialog_ptr, 1002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	update_mcss_lister($dialog_ptr);
	EVT_BUTTON($dialog_ptr, 1001, \&process_mcss_selection );
	EVT_BUTTON($dialog_ptr, 1002, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub update_mcss_lister
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my @lister_items    = ('Orange Fruit','Radish Veggy','Bike Toy','Boy Male','Ford Auto','Sun Star');
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	## set column up headers, this can also be done in the dialog itself
	$listBoxPtr->InsertColumn(   0, "Item");
	$listBoxPtr->SetColumnWidth( 0, 150 );
    $listBoxPtr->InsertColumn(   1, "Type");
	$listBoxPtr->SetColumnWidth( 1, 150 );
   	my $index;
   	my $I = 0;
   	if (scalar(@lister_items > 0))
   	{ 
      	foreach my $entry ( @lister_items ) 
      	{
			my ($colmn1,$colmn2) = split(/\s+/,$entry);
         	$index = $listBoxPtr->InsertStringItem( $I, $colmn1);
			$listBoxPtr->SetItem( $index, 1, $colmn2 );
         	$I++;
      	}
   	} else {
   		$index = $listBoxPtr->InsertStringItem( $I, 'No list items found .......');
   	}
}

################################################################################
sub process_mcss_selection
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my $listBoxPtr  = getDialogWidgetPointer( $dialog_ptr, 1000 );
   my $selectCount = $listBoxPtr->GetSelectedItemCount;
   if ( $selectCount == 0 )
   {
      Mozaix::output__warning("Please Note: A list box entry must be selected ... returning!");
      return 0;
   }
  
   ## Obtain the text of the selected dialog entry; please note that this
   ## approach ONLY returns the field of information in COLUMN 1!
   my @selectedSchematics = ();
   my $linePtr   = '';
   my $itemIndex = -1;
   my $col1	=	'';
   my $col2	=	'';
   for ( ; ; )
   {
      $itemIndex = $listBoxPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
      last if ( $itemIndex == -1 );
		## This is how you get the second column of data
      $col1 = $listBoxPtr->GetItemText( $itemIndex ) ;
      $col2 = $listBoxPtr->GetItem($itemIndex,1)->GetText;
   }
   Mozaix::output__note("	#----------------------------------------------------------#");
   Mozaix::output__note("	CURRENT SELECTION:");
   Mozaix::output__note("	     Item :[$col1]");
   Mozaix::output__note("	     Type :[$col2]");
	Mozaix::output__note("	#----------------------------------------------------------#");
} 


################################################################################
sub mcms_lister_dialog
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Multiple Column Multiple Selection WX Lister ");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::ListCtrl->new( $dialog_ptr, 1000, wxDefaultPosition, [300,120], wxLC_REPORT|wxSUNKEN_BORDER );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

	my( $item2 ) = Wx::Button->new( $dialog_ptr, 1001, "Print Selection", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::Button->new( $dialog_ptr, 1002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	update_mcms_lister($dialog_ptr);
	EVT_LIST_ITEM_SELECTED($dialog_ptr, 1000, \&set_scss_selection_color );
	EVT_BUTTON($dialog_ptr, 1001, \&process_mcms_selection );
	EVT_BUTTON($dialog_ptr, 1002, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub update_mcms_lister
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my @lister_items    = ('PN00001 res','PN00002 diode','PN00003 inductor','PN00004 res','PN00005 cap','PN00006 cap');
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	## set column up headers, this can also be done in the dialog itself
	$listBoxPtr->InsertColumn(   0, "Part Number");
	$listBoxPtr->SetColumnWidth( 0, 150 );
    $listBoxPtr->InsertColumn(   1, "Symbol Name");
	$listBoxPtr->SetColumnWidth( 1, 150 );
	$listBoxPtr->SetTextColour(Wx::wxBLUE);
   	my $index;
   	my $I = 0;
   	if (scalar(@lister_items > 0))
   	{ 
      	foreach my $entry ( @lister_items ) 
      	{
			my ($colmn1,$colmn2) = split(/\s+/,$entry);
         	$index = $listBoxPtr->InsertStringItem( $I, $colmn1);
			$listBoxPtr->SetItem( $index, 1, $colmn2 );
         	$I++;
      	}
   	} else {
   		$index = $listBoxPtr->InsertStringItem( $I, 'No list items found .......');
   	}
}


################################################################################
sub set_scss_selection_color
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	my $itemIndex = -1;
   for ( ; ; )
   {
      $itemIndex = $listBoxPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
      last if ( $itemIndex == -1 );
	  $listBoxPtr->SetItemBackgroundColour($itemIndex,Wx::wxRED);
   }
}

################################################################################
sub process_mcms_selection
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	my $itemIndex = -1;
	my $partNbr		=	'';
   	my $symbName	=	'';
	my %symbolname_X_partNumber	=	();
    for ( ; ; )
    {
      $itemIndex = $listBoxPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
      last if ( $itemIndex == -1 );
	  $partNbr 	= $listBoxPtr->GetItemText( $itemIndex ) ;
      $symbName = $listBoxPtr->GetItem($itemIndex,1)->GetText;
	  $symbolname_X_partNumber{$partNbr}	= $symbName;	
    }
	$listBoxPtr->ClearAll();
	$listBoxPtr->InsertColumn(   0, "Part Number");
	$listBoxPtr->SetColumnWidth( 0, 150 );
    $listBoxPtr->InsertColumn(   1, "Symbol Name");
	$listBoxPtr->SetColumnWidth( 1, 150 );
	$listBoxPtr->SetTextColour(Wx::wxGREEN);
	my $index;
   	my $I = 0;
	## process hash
	foreach my $partNbr (sort(keys(%symbolname_X_partNumber)))
   	{
		my $symbName = $symbolname_X_partNumber{$partNbr};  
		$index = $listBoxPtr->InsertStringItem( $I, $partNbr);
		$listBoxPtr->SetItem( $index, 1, $symbName );
		$I++;
   	}
   
}

################################################################################
sub mc_lister_dialog
################################################################################
{
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "Multiple Column WX Lister ");
	my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::ListCtrl->new( $dialog_ptr, 1000, wxDefaultPosition, [525,120], wxLC_REPORT|wxLC_SINGLE_SEL|wxSUNKEN_BORDER|wxLC_HRULES|wxLC_VRULES );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

	my( $item2 ) = Wx::Button->new( $dialog_ptr, 1001, "Print Selection", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::Button->new( $dialog_ptr, 1002, "OK", wxDefaultPosition, wxDefaultSize, 0 );
    $item0->AddWindow( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	update_mc_lister($dialog_ptr);
	EVT_BUTTON($dialog_ptr, 1001, \&process_mc_selection );
	EVT_BUTTON($dialog_ptr, 1002, \&Exit_Dialog );
	my $return_value = $dialog_ptr->ShowModal();
   	##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Checkbox Lister dialog ....");
   	}
}

################################################################################
sub update_mc_lister
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my @lister_items    = ('PN00001 res sil-8 8','PN00002 diode sm_125 1 ','PN00003 inductor sm_025 1','PN00004 res sm_128 1','PN00005 cap dip_125 1','PN00006 cap dip_125 1');
	my $listBoxPtr = getDialogWidgetPointer( $dialog_ptr, 1000);
	## set column up headers, this can also be done in the dialog itself
	$listBoxPtr->InsertColumn(   0, "Part Number");
	$listBoxPtr->SetColumnWidth( 0, 150 );
    $listBoxPtr->InsertColumn(   1, "Symbol Name");
	$listBoxPtr->SetColumnWidth( 1, 150 );
	$listBoxPtr->InsertColumn(   2, "Geometry Name");
	$listBoxPtr->SetColumnWidth( 2, 150 );
	$listBoxPtr->InsertColumn(   3, "Slot Count");
	$listBoxPtr->SetColumnWidth( 3, 75 );
   	my $index;
   	my $I = 0;
   	if (scalar(@lister_items > 0))
   	{ 
      	foreach my $entry ( @lister_items ) 
      	{
			my ($colmn1,$colmn2,$colmn3,$colmn4) = split(/\s+/,$entry);
         	$index = $listBoxPtr->InsertStringItem( $I, $colmn1);
			$listBoxPtr->SetItem( $index, 1, $colmn2 );
			$listBoxPtr->SetItem( $index, 2, $colmn3 );
			$listBoxPtr->SetItem( $index, 3, $colmn4 );
         	$I++;
      	}
   	} else {
   		$index = $listBoxPtr->InsertStringItem( $I, 'No list items found .......');
   	}
}

################################################################################
sub process_mc_selection
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my $listBoxPtr  = getDialogWidgetPointer( $dialog_ptr, 1000 );
   my $selectCount = $listBoxPtr->GetSelectedItemCount;
   if ( $selectCount == 0 )
   {
      Mozaix::output__warning("Please Note: A list box entry must be selected ... returning!");
      return 0;
   }
  
   ## Obtain the text of the selected dialog entry; please note that this
   ## approach ONLY returns the field of information in COLUMN 1!
   my @selectedSchematics = ();
   my $linePtr   = '';
   my $itemIndex = -1;
   my $col1	=	'';
   my $col2	=	'';
   my $col3	=	'';
   my $col4	=	'';
   for ( ; ; )
   {
      $itemIndex = $listBoxPtr->GetNextItem( $itemIndex, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED );
      last if ( $itemIndex == -1 );
		## This is how you get the second column of data
      $col1 = $listBoxPtr->GetItemText( $itemIndex ) ;
      $col2 = $listBoxPtr->GetItem($itemIndex,1)->GetText;
	  $col3 = $listBoxPtr->GetItem($itemIndex,2)->GetText;
	  $col4 = $listBoxPtr->GetItem($itemIndex,3)->GetText;
   }
   Mozaix::output__note("	#----------------------------------------------------------#");
   Mozaix::output__note("	CURRENT SELECTION:");
   Mozaix::output__note("	     Part Number :[$col1]");
   Mozaix::output__note("	     Symbol Name :[$col2]");
   Mozaix::output__note("	   Geometry Name :[$col3]");
   Mozaix::output__note("	      Slot Count :[$col4]");
	Mozaix::output__note("	#----------------------------------------------------------#");

}

################################################################################
sub bitmap_button_tester
################################################################################
{
	$main::bitmapState	=	1;
	my $dialog_ptr = Wx::Dialog->new(undef, -1, "WX Bitmap Tester Dialog ");
    my( $item0 ) = Wx::BoxSizer->new( wxVERTICAL );
    
    my( $item1 ) = Wx::StaticText->new( $dialog_ptr, $main::ID_TEXT, "Wx Bitmap Tester", wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE );
    $item0->AddWindow( $item1, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item2 ) = Wx::StaticLine->new( $dialog_ptr, $main::ID_LINE, wxDefaultPosition, [320,-1], wxLI_HORIZONTAL );
    $item0->AddWindow( $item2, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item3 ) = Wx::BoxSizer->new( wxHORIZONTAL );
    
	my( $item4 ) = Wx::BitmapButton->new( $dialog_ptr, 10000, Get__Bitmap(6), wxDefaultPosition, wxDefaultSize );
    $item3->AddWindow( $item4, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $item5 ) = Wx::StaticBitmap->new( $dialog_ptr, 10001, Get__Bitmap(1), wxDefaultPosition, wxDefaultSize );
    $item3->AddWindow( $item5, 0, wxALIGN_CENTER|wxALL, 5 );

    $item0->Add( $item3, 0, wxALIGN_CENTER|wxALL, 5 );

    my( $set_size ) = @_ >= 3 ? $_[2] : 1;
    my( $call_fit ) = @_ >= 2 ? $_[1] : 1;
    if( $set_size == 1 ) {
         $dialog_ptr->SetSizer( $item0 );
         
         if( $call_fit == 1 ) {
             $item0->SetSizeHints( $dialog_ptr );
         }
    }
    
    $item0;
	EVT_BUTTON($dialog_ptr, 10000, \&process_bitmap_dialog );
	my $return_value = $dialog_ptr->ShowModal();
    ##
	if ($return_value == Wx::wxID_CANCEL)
	{
        Mozaix::output__note("Canceled Print Text Example dialog ....");
    }
}

################################################################################
sub process_bitmap_dialog
################################################################################
{
	my( $dialog_ptr ) = @_;
	#
	my $static_bitmap_ptr =  getDialogWidgetPointer( $dialog_ptr, 10001);
	my $currentBitMap = $static_bitmap_ptr->GetBitmap();
	if ($main::bitmapState == 1)
	{ 
		$static_bitmap_ptr->SetBitmap(Get__Bitmap(2));
		$main::bitmapState	=	2;
	} elsif ($main::bitmapState == 2) {
		$static_bitmap_ptr->SetBitmap(Get__Bitmap(3));
		$main::bitmapState	=	3;
	} elsif ($main::bitmapState == 3) {
		$static_bitmap_ptr->SetBitmap(Get__Bitmap(4));
		$main::bitmapState	=	4;
	} elsif ($main::bitmapState == 4) {
		$static_bitmap_ptr->SetBitmap(Get__Bitmap(5));
		$main::bitmapState	=	5;
	} elsif ($main::bitmapState == 5) {
		$static_bitmap_ptr->SetBitmap(Get__Bitmap(1));
		$main::bitmapState	=	1;
	} else { ; } 
}

################################################################################
sub Get__Bitmap
################################################################################
{
	my( $indexNbr ) = @_;

    if ($indexNbr == 0) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/down_arrow.bmp", wxBITMAP_TYPE_BMP );
		my $down_arrow_bitmap_ptr	=	\$bitmap;
        return $$down_arrow_bitmap_ptr;
    }
    if ($indexNbr == 1) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/arrow_up.bmp", wxBITMAP_TYPE_BMP );
		my $show_all_bitmap_ptr	=	\$bitmap;	
        return $$show_all_bitmap_ptr;
    }
	if ($indexNbr == 2) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/arrow_right.bmp", wxBITMAP_TYPE_BMP );
		my $design_level_bitmap_ptr	=	\$bitmap;	
        return $$design_level_bitmap_ptr;
    }
	if ($indexNbr == 3) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/arrow_down.bmp", wxBITMAP_TYPE_BMP );
		my $stop_load_bitmap_ptr	=	\$bitmap;	
        return $$stop_load_bitmap_ptr;
    }
	if ($indexNbr == 4) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/arrow_left.bmp", wxBITMAP_TYPE_BMP );
		my $script_uparrow_bitmap_ptr	=	\$bitmap;	
        return $$script_uparrow_bitmap_ptr;
    }
	if ($indexNbr == 5) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/arrow_all.bmp", wxBITMAP_TYPE_BMP );
		my $zoom_out_bitmap_ptr	=	\$bitmap;	
        return $$zoom_out_bitmap_ptr;
    }
	if ($indexNbr == 6) {
        my $bitmap  = Wx::Bitmap->new("$INTERCEPT/perl_apps/WXExampleCode/examples_wdr/update.bmp", wxBITMAP_TYPE_BMP );
		my $refresh_bitmap_ptr	=	\$bitmap;	
        return $$refresh_bitmap_ptr;
    }
    wxNullBitmap;
}
   

################################################################################
sub getDialogWidgetPointer
################################################################################
{
	## get the listbox ID from the dialog
    $_[0]->FindWindow( $_[1] );
} 
